package program.zoo;

import java.util.Scanner;

public class Main {

	private static ZooList animalList = new ZooList();
	private static Scanner input = new Scanner(System.in);
	
	public static void main(String[] args) 
	{
		//instantiating the animal store method from the ZooList class
		animalList.animalStore();
		
		//main menu will loop until exit is selected
		boolean exit = false;
		int choice = 0;
		showMainMenu();
		while (!exit) 
		{
			System.out.println("\n0 to show menu options");
			System.out.print("Enter menu choice: ");
			choice = input.nextInt();
			switch (choice) {
			case 0:
				showMainMenu();
				break;
			case 1:
				animalList.getAnimalList();//method in zoo list class
				
				break;
			case 2: 
				animalList.allDetails();//method in zoo list class
				break;
			case 3:
				seeIndividualDetails();
				break;
			case 4:
				animalsByType();
				break;
			case 5:
				foodRequirements();
				break;
			case 6:
				animalsByEnvironment();
				break;
			case 7:
				System.out.println("Thank you for using the Zoo Information center");
				exit = true;
				break;

			default:
				break;
			}
		}
		
	}
	
	//method prints out menu options 
	public static void showMainMenu()
	{
		System.out.println("Welcome to the Zoo Details center");
		System.out.println("\nPlease select from the following options: ");
		System.out.println("\n1 - View List of all animals."
						+ "\n2 - View details of all animals."
						+ "\n3 - View selected animal details"
						+ "\n4 - View animals by type"
						+ "\n5 - View animals food requirments"
						+ "\n6 - View animals by environment"
						+ "\n7 - Exit the application");
	}
	
	//method used to retrieve and print individual animal details
	private static void seeIndividualDetails() 
	{
		System.out.println("\nPlease select animal to view from the following: ");
		animalList.getAnimalList();
		System.out.println("\nEnter choice: ");
		int choice = input.nextInt();
		
		switch (choice) {
		case 1:
			ZooList.getTiger();
			break;
		case 2:
			ZooList.getLion();
			break;
		case 3:
			ZooList.getSilverback();
			break;
		case 4:
			ZooList.getGibbon();
			break;
		case 5:
			ZooList.getClownFish();
			break;
		case 6:
			ZooList.getKoranAngel();
			break;
		case 7:
			ZooList.getGreatWhite();
			break;
		case 8:
			ZooList.getHammerHead();
			break;
		case 9:
			ZooList.getFalcon();
			break;
		case 10:
			ZooList.getOwl();
			break;
		case 11:
			ZooList.getLark();
			break;
		case 12:
			ZooList.getFinch();
			break;
		case 13:
			ZooList.getPython();
			break;
		case 14:
			ZooList.getBoa();
			break;
		case 15:
			ZooList.getNile();
			break;
		case 16:
			ZooList.getFreshWater();
			break;
		default:
			
			break;
		}
	}
	
	//method to print a list of animals by selected animal class
	private static void animalsByType() 
	{
		System.out.println("Current catagory list of animals in the zoo:"
						+ "\nMammal"
						+ "\nFish"
						+ "\nBird"
						+ "\nReptile");
		System.out.print("Please type the catagory you wish to view: ");
		String choice = input.next();
		animalList.getCategory(choice);
	}
	
	//method to print out a full list of food
	//or print food by animal class
	private static void foodRequirements() 
	{
		System.out.println("Please select from the following:"
						+ "\n1 - View food for all animals"
						+ "\n2 - View food for a catagory");
		int choice = input.nextInt();
		if (choice == 1) 
		{
			animalList.printFeed();
		}
		if(choice == 2)
		{
			System.out.println("Please type a category from the following: "
							+ "\nMammal"
							+ "\nFish"
							+ "\nBird"
							+ "\nReptile");
			System.out.print("Enter: ");
			String cat = input.next();
			animalList.findCategory(cat);
		}
		
	}
	
	//method to print a list of animals by selected environment
	private static void animalsByEnvironment() 
	{
		System.out.println("We have animals from the following environments:"
						+ "\nJungle"
						+ "\nDesert"
						+ "\nFresh water"
						+ "\nSea"
						+ "\nCountryside"
						+ "\nGrassland"
						+ "\nWoodland");
		System.out.println("Please type the category you wish to veiw");
		System.out.print("Enter: ");
		String choice = input.next();
		animalList.getEnviro(choice);
	}

}
