package program.zoo;

import java.util.ArrayList;

public class ZooList
{
	//create arraylist of type animal to store and animals in
	private static ArrayList<Animal>animalList = new ArrayList<Animal>();
	private static ArrayList<Animal>animalQuery = new ArrayList<Animal>();
	
	//initialising zoo animals
	//animal objects then created animalStore() method
	private static BigCat tiger;
	private static BigCat lion;
	private static Apes silverback;
	private static Apes gibbon;
	private static TropicalFish clownFish;
	private static TropicalFish koranAngel;
	private static Sharks greatWhite;
	private static Sharks hammerHead;
	private static BirdsOfPray falcon;
	private static BirdsOfPray owl;
	private static SongBirds lark;
	private static SongBirds finch;
	private static Snake python;
	private static Snake boa;
	private static Crocodile nile;
	private static Crocodile freshWater;
	
	//method to contain all animal objects
	public void animalStore()
	{
		tiger = new BigCat("Larry", 4, 200,
				"Big cat from a jungle",
				"Mammal",
				"Jungle",
				"Meat",
				"Hair",
				"Orange, black stripes",
				"Short ears",
				"Bengal Tiger");
		animalList.add(tiger);
		
		lion = new BigCat("Nigel", 2, 170,
				"Big cat from the sahara",
				"Mammal",
				"Grassland",
				"Meat",
				"Hair",
				"Yellow, tan",
				"Short ears",
				"African Lion");
		animalList.add(lion);
		
		silverback = new Apes("Julius", 10, 200,
					"A silverback from Africa",
					"Mammal",
					"Jungle",
					"Foliage",
					"Hair",
					"Black and silver",
					"Short ears",
					"Mountain gorilla");
		animalList.add(silverback);
		
		gibbon = new Apes("Commodus", 5, 5,
				"A gibbon from Vietnam",
				"Mammal",
				"Jungle",
				"Foliage",
				"Hair",
				"Black",
				"Short ears",
				"Black crested gibbon");
		animalList.add(gibbon);
		
		clownFish = new TropicalFish("Augustus", 3, 0.25,
				"A fish from the sea",
				"Fish",
				"Sea",
				"Meat",
				4,
				"Orange with balck and white bands",
				false,
				true,
				"Percula clownfish");
		animalList.add(clownFish);
		
		koranAngel = new TropicalFish("Domitian", 1, 1.2,
				"Also a fish from the sea",
				"Fish",
				"Sea",
				"meat",
				11.5,
				"Blue with white bands",
				false,
				true,
				"Angel fish");
		animalList.add(koranAngel);
		
		greatWhite = new Sharks("Hadrian", 7, 750,
				"Apex predator of the seas",
				"Fish",
				"Sea",
				"Fish",
				17,
				"Gray/blue and white",
				false,
				true,
				"Mackerel shark");
		animalList.add(greatWhite);
		
		hammerHead = new Sharks("Otho", 5, 75.5,
				"Like a hammer but in the sea",
				"Fish",
				"Sea",
				"Fish",
				12,
				"Silver",
				false,
				true,
				"Scalloped hammerhead");
		animalList.add(hammerHead);
		
		falcon = new BirdsOfPray("maximus", 3, 1.2,
				"Fastest member of the animal kingdom",
				"Bird",
				"Contryside",
				"Meat",
				110,
				"Hooked beak",
				true,
				true,
				"Peregine falcon");
		animalList.add(falcon);
		
		owl = new BirdsOfPray("Severus", 2, 1,
				"Is a very large owl",
				"Bird",
				"Woodland",
				"Meat",
				140,
				"Hooked beak",
				false,
				true,
				"Great grey owl");
		animalList.add(owl);
		
		lark = new SongBirds("Galba", 3, 0.75,
				"Often found larking around..",
				"Bird",
				"Grassland",
				"Seed",
				30,
				"Straight pointed beak",
				false,
				true,
				"Black eared sparrow-lark");
		animalList.add(lark);
		
		finch = new SongBirds("Pertinax", 4, 0.8,
				"Sings a nice song",
				"Bird",
				"Woodland",
				"Seed",
				27,
				"Straight pointed beak",
				false,
				true,
				"Bullfinch");
		animalList.add(finch);
		
		python = new Snake("Nero", 10, 40,
				"The animal not the coding language",
				"Reptile",
				"Jungle",
				"Meat",
				"lateral undulation",
				"Small",
				"Dark and light brown",
				"Burmese python");
		animalList.add(python);
		
		boa = new Snake("Claudius", 5, 20,
				"Classic constictor",
				"Reptile",
				"Jungle",
				"Meat",
				"lateral undulation",
				"Small",
				"Light brown and red",
				"Red tailed boa");
		animalList.add(boa);
		
		nile = new Crocodile("Vespasian", 25, 600,
				"Lived with the ancient egyptians",
				"Reptile",
				"Fresh water",
				"Meat",
				"Walking",
				"Large",
				"Green/grey",
				"Nile crocodile");
		animalList.add(nile);
		
		freshWater = new Crocodile("Marcus", 12, 65,
				"Live down under",
				"Reptile",
				"Fresh water",
				"Meat",
				"Walking",
				"Large",
				"Olive green and black",
				"Fresh water crocodile");
		animalList.add(freshWater);
	}
	
	
	//method to list animal food requirements 
	public void printFeed()
	{
		for (int i = 0; i < animalList.size(); i++) 
		{
			System.out.println("Animal: " + animalList.get(i).getName() +
								" Type: " + animalList.get(i).getAnimalClass() +
								" Feed: " + animalList.get(i).getFeed());
		}
	}


	//method searches for and returns animals in a selected environment
	Animal getEnviro(String enviro)
	{
		for(Animal animal : animalList)
		{
			if(animal.getEnvironment().equalsIgnoreCase(enviro))
			{
				animalQuery.add(animal);
			}
		}
		for(Animal animal : animalQuery)
		{
			System.out.println(animal.getName() + ": " + "Environment: " + animal.getEnvironment());
		}
		animalQuery.clear();
		return null;
	}
	
	//method to search for a select animal type and
	//stores then in the animalQuery array list then prints
	//the animals from that list
	Animal getCategory(String category)
	{
		for(Animal animal : animalList)
		{
			if(animal.getAnimalClass().equalsIgnoreCase(category))
			{
				animalQuery.add(animal);
			}
		}
		for(Animal animal : animalQuery) 
		{
			System.out.println(animal.getAnimalClass() + " - " + animal.getName());
			
		}
		animalQuery.clear();
		return null;
	}
	
	//method to search and return selected food categories
	Animal findCategory(String category)
	{
		for(Animal animal : animalList)
		{
			if(animal.getAnimalClass().equalsIgnoreCase(category))
			{
				animalQuery.add(animal);
			}
		}
		for(Animal animal : animalQuery)
		{
			System.out.println(animal.getAnimalClass() + " - " + animal.getName() + " - " + animal.getFeed());
		}
		animalQuery.clear();
		return null;
	}
	
	//method to display list of current animals 
	public ArrayList<Animal> getAnimalList()
	{
		System.out.println("Total animals in the zoo: " + animalList.size());
		
		for (int i = 0; i < animalList.size(); i++) 
		{
			System.out.println((i+1) + " - " + animalList.get(i).getName() + ", " + animalList.get(i).getDescription());
		}
		return animalList;
	}
	
	//method to print out a list of all animal details
	public void allDetails()
	{
		tiger.printAnimal();
		lion.printAnimal();
		silverback.printAnimal();
		gibbon.printAnimal();
		clownFish.printAnimal();
		koranAngel.printAnimal();
		greatWhite.printAnimal();
		hammerHead.printAnimal();
		falcon.printAnimal();
		owl.printAnimal();
		lark.printAnimal();
		finch.printAnimal();
		python.printAnimal();
		boa.printAnimal();
		nile.printAnimal();
		freshWater.printAnimal();
	}

	
	//get methods for displaying animal details
	public static BigCat getTiger() {
		tiger.printAnimal();
		return tiger;
	}

	public static BigCat getLion() {
		lion.printAnimal();
		return lion;
	}

	public static Apes getSilverback() {
		silverback.printAnimal();
		return silverback;
	}

	public static Apes getGibbon() {
		gibbon.printAnimal();
		return gibbon;
	}

	public static TropicalFish getClownFish() {
		clownFish.printAnimal();
		return clownFish;
	}

	public static TropicalFish getKoranAngel() {
		koranAngel.printAnimal();
		return koranAngel;
	}

	public static Sharks getGreatWhite() {
		greatWhite.printAnimal();
		return greatWhite;
	}

	public static Sharks getHammerHead() {
		hammerHead.printAnimal();
		return hammerHead;
	}

	public static BirdsOfPray getFalcon() {
		falcon.printAnimal();
		return falcon;
	}

	public static BirdsOfPray getOwl() {
		owl.printAnimal();
		return owl;
	}

	public static SongBirds getLark() {
		lark.printAnimal();
		return lark;
	}

	public static SongBirds getFinch() {
		finch.printAnimal();
		return finch;
	}

	public static Snake getPython() {
		python.printAnimal();
		return python;
	}

	public static Snake getBoa() {
		boa.printAnimal();
		return boa;
	}

	public static Crocodile getNile() {
		nile.printAnimal();
		return nile;
	}

	public static Crocodile getFreshWater() {
		freshWater.printAnimal();
		return freshWater;
	}

}
